DEFINE VARIABLE iModulo          AS INTEGER   NO-UNDO INITIAL 100.
DEFINE VARIABLE sp-companyCode   AS CHARACTER NO-UNDO INITIAL 'euc'.
DEFINE VARIABLE lCorrectDB       AS LOGICAL   NO-UNDO INITIAL NO.
DEFINE VARIABLE cFileD           AS CHARACTER NO-UNDO. cFileD   = SESSION:TEMP-DIRECTORY + 'ca-cntr-check.d'.
DEFINE VARIABLE cFileTxt         AS CHARACTER NO-UNDO. cFileTxt = SESSION:TEMP-DIRECTORY + 'ca-cntr-check.txt'.
                                    &SCOPED-DEFINE vesselMatch  GE 290999

DEFINE VARIABLE iDone            AS INTEGER   NO-UNDO.
DEFINE VARIABLE cAction          AS CHARACTER NO-UNDO.
DEFINE VARIABLE i                AS INTEGER   NO-UNDO.
DEFINE TEMP-TABLE tt NO-UNDO
  /*uit voyage_container*/
  FIELD vesselNr           AS INTEGER 
  FIELD cntrPrefix         AS CHARACTER FORMAT 'X(4)'
  FIELD cntrNr             AS CHARACTER FORMAT 'X(7)'
  FIELD voyCntrRID         AS ROWID
  FIELD shpCntrRID         AS ROWID
  FIELD indDelShpCntr      AS LOGICAL
  FIELD indDelVoyCntr      AS LOGICAL
  FIELD indUpdVoyCntr      AS LOGICAL
  /*-- uit shipment_item_container --*/
  FIELD numShipmentCntrs   AS INTEGER 
  FIELD msg                AS CHARACTER
  INDEX cntr               AS PRIMARY UNIQUE 
        cntrPrefix         ASCENDING
        cntrNr             ASCENDING
        vesselNr           ASCENDING .
DEFINE BUFFER btt FOR tt.

FORM "Action   :" AT 1 cAction    NO-LABEL  FORMAT "x(64)"         AT 12  SKIP
     "Done     :" AT 1 iDone      NO-LABEL  FORMAT "->>>,>>>,>>9"  AT 12  SKIP   
     WITH FRAME a VIEW-AS DIALOG-BOX.
&GLOBAL-DEFINE mydisplay cAction iDone  WITH FRAME a
/*****************************************************************************/
cAction = 'checking Voyage containers'.
iDone   = 0.
DISPLAY {&mydisplay}.   
FOR EACH ca-u_voyage_container NO-LOCK 
   WHERE ca-u_voyage_container.companyCode    EQ sp-companyCode 
     AND ca-u_voyage_container.inward-outward EQ 'o'
     AND ca-u_voyage_container.vesselnr       {&vesselMatch} :
   CREATE tt.
   ASSIGN tt.vesselNr   = ca-u_voyage_container.vesselnr
          tt.cntrPrefix = ca-u_voyage_container.containerprefix 
          tt.cntrNr     = ca-u_voyage_container.containernr
          tt.voyCntrRID = ROWID(ca-u_voyage_container)
          .    
   FOR EACH ca-u_shipment FIELDS(vesselnr bookingnr) NO-LOCK
      WHERE ca-u_shipment.companycode                    EQ sp-companyCode
        AND ca-u_shipment.vesselnr                       EQ ca-u_voyage_container.vesselnr ,
       EACH ca-u_shipment_item_container FIELDS(vesselnr) NO-LOCK
      WHERE ca-u_shipment_item_container.companycode     EQ sp-companyCode
        AND ca-u_shipment_item_container.shipment_seqnr  EQ ca-u_shipment.shipment_seqnr
        AND ca-u_shipment_item_container.containerprefix EQ ca-u_voyage_container.containerprefix
        AND ca-u_shipment_item_container.containernr     EQ ca-u_voyage_container.containernr :
      tt.numShipmentCntrs = tt.numShipmentCntrs + 1.
      IF ca-u_shipment.vesselnr NE ca-u_shipment_item_container.vesselnr 
      THEN tt.msg = LEFT-TRIM( tt.msg + CHR(10) 
                             + SUBSTITUTE('Shipment &1 vesselNr mismatch ship:&2 - cntr:&3'
                                         ,ca-u_shipment.bookingnr
                                         ,ca-u_shipment.vesselnr
                                         ,ca-u_shipment_item_container.vesselnr)
                             , CHR(10)).
   END. /*ca-u_shipment*/
   iDone = iDone + 1.
   IF iDone MODULO iModulo EQ 0 
   THEN DO:
      DISPLAY {&mydisplay}.   
      PROCESS EVENTS. 
   END.
END.
/*****************************************************************************/
iDone = 0.
cAction = 'checking shipment containers'.
DISPLAY {&mydisplay}.   
cntr:
FOR EACH ca-u_shipment_item_container FIELDS(vesselnr shipment_seqNr item_seqNr containerPrefix containerNr) NO-LOCK 
   WHERE ca-u_shipment_item_container.companycode EQ sp-companyCode
     AND ca-u_shipment_item_container.vesselnr    {&vesselMatch}:
   iDone = iDone + 1.
   IF iDone MODULO iModulo EQ 0 
   THEN DO:
      DISPLAY {&mydisplay}.   
      PROCESS EVENTS. 
   END.
   FIND     tt NO-LOCK 
      WHERE tt.vesselNr   EQ ca-u_shipment_item_container.vesselnr
        AND tt.cntrPrefix EQ ca-u_shipment_item_container.containerprefix
        AND tt.cntrNr     EQ ca-u_shipment_item_container.containernr NO-ERROR.
   
   IF AVAILABLE tt
   THEN DO:
      NEXT cntr.
   END.
   
   FIND     ca-u_shipment NO-LOCK
      WHERE ca-u_shipment.companycode    EQ sp-companyCode
        AND ca-u_shipment.shipment_seqnr EQ ca-u_shipment_item_container.shipment_seqnr NO-ERROR.
        
   CREATE tt.
   ASSIGN tt.vesselNr   = ca-u_shipment_item_container.vesselnr
          tt.cntrPrefix = ca-u_shipment_item_container.containerprefix
          tt.cntrNr     = ca-u_shipment_item_container.containernr
          tt.shpCntrRID = ROWID(ca-u_shipment_item_container) .
   
   IF NOT AVAILABLE ca-u_shipment 
   THEN DO:
      tt.msg           = 'Missing shipment record nr= ' + STRING(ca-u_shipment_item_container.shipment_seqnr).
      tt.indDelShpCntr = YES.
      NEXT cntr. 
   END.
   ASSIGN tt.msg        = (IF AMBIGUOUS tt 
                           THEN SUBSTITUTE('AMBIGUOUS voyage container record FOR booking &1 ITEM &2',ca-u_shipment.bookingnr,ca-u_shipment_item_container.item_seqnr)
                           ELSE SUBSTITUTE('Missing voyage container record FOR booking &1 ITEM &2'  ,ca-u_shipment.bookingnr,ca-u_shipment_item_container.item_seqnr) 
                          )
                        + (IF ca-u_shipment.vesselnr NE ca-u_shipment_item_container.vesselnr
                           THEN CHR(10) + SUBSTITUTE('Shipment &1 vesselNr mismatch ship:&2 - cntr:&3',ca-u_shipment.bookingnr,ca-u_shipment.vesselnr,ca-u_shipment_item_container.vesselnr)
                           ELSE '')
                        .
END. /*ca-u_shipment_item_container*/
/*****************************************************************************/
/*-- matching cntr records --*/
FOR EACH tt /*voyageCntr zonder shipmentCntr*/
   WHERE tt.numShipmentCntrs EQ 0 
     AND tt.voyCntrRID       NE ? ,
    EACH btt /*shipmentCntr zonder voyageCntr*/
   WHERE btt.shpCntrRID    NE ? 
     AND btt.vesselNr      NE tt.vesselNr
     AND btt.cntrPrefix    EQ tt.cntrPrefix
     AND btt.cntrNr        EQ tt.cntrNr
     AND btt.indDelShpCntr EQ NO :
   tt.msg               = LEFT-TRIM( tt.msg + CHR(10) + SUBSTITUTE('vesselnr MISMATCH &1 --> &2',tt.vesselNr,btt.vesselNr), CHR(10)).
   btt.vesselNr         = btt.vesselNr * -1. /*anders is tt niet op nieuwe vessel te zetten*/
   tt.numShipmentCntrs  = 1.
   tt.vesselNr          = ABSOLUTE(btt.vesselNr).
   tt.indUpdVoyCntr     = YES.
            
   DELETE btt.
END. /*tt*/
/*****************************************************************************/
FOR EACH tt 
   WHERE tt.numShipmentCntrs LE 0 
     AND tt.voyCntrRID       NE ? :
   tt.msg = LEFT-TRIM( tt.msg + CHR(10) + 'Missing shipment container record  numContainers= ' + STRING(tt.numShipmentCntrs), CHR(10)).   
   tt.indDelVoyCntr = YES.                 
END.
/*****************************************************************************/
/*-- correctie --*/
IF lCorrectDB 
THEN DO:
   /*-- herkoppelen containers --*/   
   FOR EACH tt WHERE tt.indUpdVoyCntr
                 AND tt.voyCntrRID NE ?,
       FIRST ca-u_voyage_container EXCLUSIVE-LOCK 
       WHERE ROWID(ca-u_voyage_container) EQ tt.voyCntrRID:
       ca-u_voyage_container.vesselnr = tt.vesselNr.
       tt.msg = LEFT-TRIM( tt.msg + CHR(10) + 'ca-voyage_container vesselnr CHANGED', CHR(10)).
   END. 
   
   /*-- voyage cntrs zonder shipment cntrs verwijderen --*/
   FOR EACH tt WHERE tt.indDelVoyCntr
                 AND tt.voyCntrRID NE ?,
       FIRST ca-u_voyage_container EXCLUSIVE-LOCK 
       WHERE ROWID(ca-u_voyage_container) EQ tt.voyCntrRID.
      DELETE ca-u_voyage_container.
      tt.msg = LEFT-TRIM( tt.msg + CHR(10) + 'ca-voyage_container DELETED', CHR(10)).
   END.
   
   /*-- shipmentCntr zonder shipment record verwijdern --*/
   FOR EACH tt WHERE tt.indDelShpCntr
                 AND tt.shpCntrRID    NE ?, 
      FIRST ca-u_shipment_item_container EXCLUSIVE-LOCK 
      WHERE ROWID(ca-u_shipment_item_container) EQ tt.shpCntrRID.
      DELETE ca-u_shipment_item_container.
      tt.msg = LEFT-TRIM( tt.msg + CHR(10) + 'ca-u_shipment_item_container DELETED', CHR(10)).
   END.
   
   /*-- shipmentCntr zonder voyCntr -> voyCntr aanmaken --*/
   
END.
/*****************************************************************************/

OUTPUT TO VALUE(cFileD).
FOR EACH tt:
   EXPORT tt EXCEPT voyCntrRID shpCntrRID.
END.
OUTPUT CLOSE.
OUTPUT TO VALUE(cFileTxt).
FOR EACH tt WHERE tt.msg NE '':
   PUT UNFORMATTED SKIP tt.cntrPrefix + ' ' + tt.cntrNr.
   DO i = 1 TO NUM-ENTRIES(tt.msg,CHR(10)):
      PUT UNFORMATTED ENTRY(i,tt.msg,CHR(10)) AT 15 SKIP .
   END.
END.
OUTPUT CLOSE.
OS-COMMAND NO-WAIT VALUE('notepad ' + cFileTxt).
 
MESSAGE 'done'.

